classification
Title: logging.handlers.MemoryHandler flushes on shutdown but not removal
Type: behavior Stage: resolved
Components: Library (Lib) Versions: Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: David Escott, python-dev, vinay.sajip
Priority: normal Keywords:

Created on 2016-03-14 18:01 by David Escott, last changed 2016-07-22 15:28 by python-dev. This issue is now closed.

Messages (2)
msg261772 - (view) Author: David Escott (David Escott) Date: 2016-03-14 18:01
The documentation suggests using a MemoryHandler object to buffer log messages and conditionally output them. https://docs.python.org/3/howto/logging-cookbook.html#buffering-logging-messages-and-outputting-them-conditionally

However the documentation does not make clear that this only works because of the call to super(MemoryHandler, handler).flush() prior to logger.removeHandler(handler).

A direct call to handler.flush(), or simply leaving the handler unflushed until process shutdown will result in the messages still being printed, when the MemoryHandler calls self.flush() during its shutdown routines.

To be honest this behavior of MemoryHandler doesn't make much sense to me, since the MemoryHandler is in fact flushing when flush_level has not been satisfied.

I would suggest adding an option to the MemoryHandler "flush_on_close" defaulting to True, and then simply constructing the MemoryHandler with that option set to False. That would not affect the existing users of the handler, but it would result in a tool which would actually match the only example I have come across of a MemoryHandler in use online.
msg270993 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2016-07-22 15:28
New changeset a399daacb591 by Vinay Sajip in branch 'default':
Closes #26559: Allow configuring flush-on-close behaviour of MemoryHandler.
https://hg.python.org/cpython/rev/a399daacb591
History
Date User Action Args
2016-07-22 15:28:43python-devsetstatus: open -> closed

nosy: + python-dev
messages: + msg270993

resolution: fixed
stage: resolved
2016-03-15 02:41:58ned.deilysetnosy: + vinay.sajip
2016-03-14 18:01:46David Escottcreate